import * as React from 'react';
import type { RadioProps, RadioState } from './types';
import type { ChangeEvent } from 'react';
declare class Radio extends React.Component<RadioProps, RadioState> {
    static defaultProps: {
        overrides: {};
        containsInteractiveElement: boolean;
        checked: boolean;
        disabled: boolean;
        autoFocus: boolean;
        inputRef: React.RefObject<HTMLInputElement>;
        align: string;
        error: boolean;
        onChange: () => void;
        onMouseEnter: () => void;
        onMouseLeave: () => void;
        onMouseDown: () => void;
        onMouseUp: () => void;
        onFocus: () => void;
        onBlur: () => void;
    };
    state: {
        isActive: boolean;
        isHovered: boolean;
    };
    componentDidMount(): void;
    onMouseEnter: (e: ChangeEvent<HTMLInputElement>) => void;
    onMouseLeave: (e: ChangeEvent<HTMLInputElement>) => void;
    onMouseDown: (e: ChangeEvent<HTMLInputElement>) => void;
    onMouseUp: (e: ChangeEvent<HTMLInputElement>) => void;
    render(): JSX.Element;
}
export default Radio;
